-- @Autor: WarezLine
-- @Version 1.0.0
MC_Motor = {};
MC_Motor.ModName = g_currentModName;

function MC_Motor.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(FillUnit, specializations)
end

function MC_Motor.registerEventListeners(vehicleType)
    for _,e in pairs({"onLoad","onDraw","saveToXMLFile","onRegisterActionEvents"}) do
        SpecializationUtil.registerEventListener(vehicleType, e, MC_Motor)
    end
end

function MC_Motor:onRegisterActionEvents(isSelected, isOnActiveVehicle)
    if isOnActiveVehicle and g_currentMission.controlledVehicle ~= nil then
        local _, evFuel = self:addActionEvent(g_inputBinding, 'KEYFUEL', self, MC_Motor.Activar, false, true, false, true, nil)
        g_inputBinding:setActionEventTextPriority(evFuel, 2);
        local _, evFuelFill = self:addActionEvent(g_inputBinding, 'KEYFUELFILL', self, MC_Motor.Activar, false, true, false, true, nil)
        g_inputBinding:setActionEventTextPriority(evFuelFill, 2);
    end
end

function MC_Motor:Activar(actionName, keyStatus, arg3, arg4, arg5)
    if self.spec_fillUnit ~= nil and self.spec_fillUnit.fillUnits ~= nil then
        if actionName == "KEYFUEL" then self.xFuel = (self.xFuel + 1) end
        if self.xFuel > 10 then self.xFuel = 1 end;
        for i,obj in pairs(self.spec_fillUnit.fillUnits) do
            if obj.MC_capacity == nil then obj.MC_capacity = obj.capacity; end;
			if obj.fillType == 32 or obj.fillType == 17 then
				obj.capacity = obj.MC_capacity * self.xFuel
            end
            if actionName == "KEYFUELFILL" and (obj.fillType == 32 or obj.fillType == 17) then
                obj.fillLevel = obj.capacity
            end
        end
	end
end

function MC_Motor:onLoad(savegame)
    self.xFuel = 1;
    if savegame ~= nil then
        local key = savegame.key .. ".MC_Motor"		
        local iFactor = getXMLInt(savegame.xmlFile, key.."#XFuel")
        if iFactor ~= nil and iFactor > 1 and iFactor < 11 then
            self.xFuel = iFactor
        end
    end
    if self.spec_fillUnit ~= nil and self.spec_fillUnit.fillUnits ~= nil then
        for _,obj in pairs(self.spec_fillUnit.fillUnits) do
            obj.MC_capacity=obj.capacity
            if obj.fillType == 32 or obj.fillType == 17 then
                obj.capacity = obj.capacity * self.xFuel
            end
        end
    end
end

function MC_Motor:saveToXMLFile(xmlFile, key)
    if self.xFuel ~= 1 then
        setXMLInt(xmlFile, key.."#XFuel", self.xFuel)
    end
end

function MC_Motor:onDraw(isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
    for i,obj in pairs(self.spec_fillUnit.fillUnits) do
        if obj.fillType == 32 or obj.fillType == 17 then
            g_currentMission:addExtraPrintText(string.format(g_i18n.modEnvironments[MC_Motor.ModName].texts.CapacidadFuel, self.xFuel, obj.capacity));
        end
    end
end
