-- @Autor: WarezLine
-- @Version 1.1.0
MultiCheat = {
	obj={},
	iKeySilo=nil,
	iKeyAnim=nil,
	iKeyMoney=nil,
	iMaxCap=10
};
MultiCheat.ModName = g_currentModName;

addModEventListener(MultiCheat);

-- Verifica la visibilidad de los menus.
function MultiCheat:update(dt)
	MultiCheat.iKeySilo = nil
	MultiCheat.iKeyAnim = nil
	MultiCheat.iKeyMoney = nil
	local px,py,pz = getWorldTranslation(g_currentMission.player.rootNode)
	for index, obj in pairs(MultiCheat.obj) do
		local ox,oy,oz = getWorldTranslation(obj.id)
		local ds = MathUtil.vector3Length(px-ox,py-oy,pz-oz)
		if ds < obj.dist and obj.tipo == 1 then
			MultiCheat.iKeySilo=index;
		elseif ds < obj.dist and obj.tipo == 2 then
			MultiCheat.iKeyAnim=index;
		end
		if ds < obj.dist then
			MultiCheat.iKeyMoney=index;
		end
	end
	MultiCheat:Menu();
end

-- Agrega los objetos al controlador.
Placeable.finalizePlacement = Utils.appendedFunction(Placeable.finalizePlacement, function(self)
	local cls = self.className
	local obj = {dist=5,obj=self,del=self.nodeId,id=self.nodeId,tipo=1}
	local y=false
	if cls == "SiloPlaceable" and #self.levelAreas > 0 then
		self.MultiCheat = {Capacity=self.storages[1].capacityPerFillType,xCap=1}
		obj.dist,obj.id = 10,self.unloadingStation.unloadTriggers[1].exactFillRootNode
		y=true
	elseif cls == "AnimalHusbandry" and self.modulesByName.animals.animalType ~= "DOG" then
		obj.tipo, obj.id = 2,self.modulesById[1].animalLoadingTrigger.triggerNode
		y=true
	elseif cls == "Workshop" or cls == "BuyingStationPlaceable" or cls == "SellingStationPlaceable" then
		obj.tipo=3
		y=true
	end;
	if y then table.insert(MultiCheat.obj, obj); end;
end);

-- Eliminar los objetos del controlador.
Placeable.delete = Utils.appendedFunction(Placeable.delete, function(self)
	if self.className == "SiloPlaceable" or self.className == "AnimalHusbandry" or self.className == "SellingStationPlaceable" or self.className == "Workshop" or self.className == "BuyingStationPlaceable" then
		for index, obj in pairs(MultiCheat.obj) do
			if obj.del == self.nodeId then
				print("eliminando no se que")
				table.remove(MultiCheat.obj, index);
			end
		end
	end;
end);

-- Guardar cualquier cambio.
Placeable.saveToXMLFile = Utils.appendedFunction(Placeable.saveToXMLFile, function(self, xmlFile, key, usedModNames)
	if self.className == "SiloPlaceable" and self.MultiCheat ~= nil then
		setXMLInt(xmlFile, key.."#XCap", self.MultiCheat.xCap)
	end
end);

-- Cargar los cambios
Placeable.loadFromXMLFile = Utils.overwrittenFunction(Placeable.loadFromXMLFile, function(self, superFunc, xmlFile, key, resetVehicles)
	local ret = superFunc(self, xmlFile, key, resetVehicles)
	if self.className == "SiloPlaceable" and self.MultiCheat ~= nil then
		local obj = self.MultiCheat
		local iFactor = getXMLInt(xmlFile, key.."#XCap")
		if iFactor ~= nil and iFactor > 2 and iFactor <= MultiCheat.iMaxCap then
			obj.xCap = iFactor
			if iFactor > 1 then
				self.storages[1].capacityPerFillType = obj.xCap * obj.Capacity
			end
		end
	end
	return ret;
end);

-- Registra los menus
function MultiCheat:registerActionEvents()
	_, MultiCheat["KEYSILO"] = g_inputBinding:registerActionEvent("KEYSILO", self, MultiCheat.Action ,false ,true ,false ,true);
	_, MultiCheat["KEYSILOCAP"] = g_inputBinding:registerActionEvent("KEYSILOCAP", self, MultiCheat.Action ,false ,true ,false ,true);
	_, MultiCheat["KEYANIM"] = g_inputBinding:registerActionEvent("KEYANIM", self, MultiCheat.Action ,false ,true ,false ,true);
	_, MultiCheat["KEYMONEY"] = g_inputBinding:registerActionEvent("KEYMONEY", self, MultiCheat.Action ,false ,true ,false ,true);
	_, MultiCheat["KEYREPARAR"] = g_inputBinding:registerActionEvent("KEYREPARAR", self, MultiCheat.Action ,false ,true ,false ,true);
	MultiCheat:Menu();
end
BaseMission.registerActionEvents = Utils.appendedFunction(BaseMission.registerActionEvents , MultiCheat.registerActionEvents);

-- Muestra o culta los menu.
function MultiCheat:Menu()
	-- Menu de los silos
	local yes={MultiCheat.iKeySilo ~= nil,MultiCheat.iKeyAnim ~= nil,MultiCheat.iKeyMoney ~= nil}
	g_inputBinding:setActionEventTextVisibility(MultiCheat["KEYSILO"], yes[1])
	g_inputBinding:setActionEventActive(MultiCheat["KEYSILO"], yes[1])
	g_inputBinding:setActionEventTextPriority(MultiCheat["KEYSILO"], 2);
	-- Menu de tamaño del silo
	g_inputBinding:setActionEventTextVisibility(MultiCheat["KEYSILOCAP"], yes[1])
	g_inputBinding:setActionEventActive(MultiCheat["KEYSILOCAP"], yes[1])
	g_inputBinding:setActionEventTextPriority(MultiCheat["KEYSILOCAP"], 2);
	if MultiCheat.iKeySilo ~= nil then
		g_currentMission:addExtraPrintText(string.format(g_i18n.modEnvironments[MultiCheat.ModName].texts.Capacidad, MultiCheat.obj[MultiCheat.iKeySilo].obj.MultiCheat.xCap, MultiCheat.obj[MultiCheat.iKeySilo].obj.storages[1].capacityPerFillType));
	end
	-- Menu de los corrales.
	g_inputBinding:setActionEventTextVisibility(MultiCheat["KEYANIM"], yes[2])
	g_inputBinding:setActionEventActive(MultiCheat["KEYANIM"], yes[2])
	g_inputBinding:setActionEventTextPriority(MultiCheat["KEYANIM"], 2);
	-- Menu de los cajeros.
	g_inputBinding:setActionEventTextVisibility(MultiCheat["KEYMONEY"], yes[3])
	g_inputBinding:setActionEventActive(MultiCheat["KEYMONEY"], yes[3])
	g_inputBinding:setActionEventTextPriority(MultiCheat["KEYMONEY"], 2);
	-- Menu de reparar todos los vehiculos
	g_inputBinding:setActionEventTextVisibility(MultiCheat["KEYREPARAR"], yes[3] and MultiCheat.obj[MultiCheat.iKeyMoney].obj.className == "Workshop")
	g_inputBinding:setActionEventActive(MultiCheat["KEYREPARAR"], yes[3] and MultiCheat.obj[MultiCheat.iKeyMoney].obj.className == "Workshop")
	g_inputBinding:setActionEventTextPriority(MultiCheat["KEYREPARAR"], 2);
end

-- Accion segun el menu utilizado.
function MultiCheat:Action (actionName, keyStatus)
	-- Rellenar silo.
	if actionName == "KEYSILO" and MultiCheat.iKeySilo ~= nil then
		local obj = MultiCheat.obj[MultiCheat.iKeySilo].obj.storages[1];
		for filtype, _ in pairs(obj.fillTypes) do
			obj.fillLevels[filtype] = obj.capacityPerFillType;
		end
	end
	-- Cambiar la capacidad de carga.
	if actionName == "KEYSILOCAP" and MultiCheat.iKeySilo ~= nil then
		local obj = MultiCheat.obj[MultiCheat.iKeySilo].obj
		local cnf = obj.MultiCheat
		cnf.xCap = (cnf.xCap + 1)
        if cnf.xCap > MultiCheat.iMaxCap then cnf.xCap = 1 end;
		obj.storages[1].capacityPerFillType = cnf.xCap * cnf.Capacity
	end
	-- Reparar todos los vehiculos.
	if actionName == "KEYREPARAR" and MultiCheat.iKeyMoney ~= nil then
		for _,obj in pairs(g_currentMission.ownedItems) do
			for _,obj2 in pairs(obj.items) do
				if obj2.className == "Vehicle" then
					obj2.dirtyMask = 0
					obj2.isBroken =false
					if obj2.spec_dashboard ~= nil then obj2.spec_dashboard.isDirty=false end
					if obj2.spec_wearable ~= nil then 
						for _,obj3 in pairs(obj2.spec_wearable.wearableNodes) do
							obj2:setNodeWearAmount(obj3, 0, true)
						end
					end
					if obj2.spec_washable ~= nil then
						for _,obj3 in pairs(obj2.spec_washable.washableNodes) do
							obj2:setNodeDirtAmount(obj3, 0, true)
						end
					end
				end
			end
		end
	end
	-- Mantenimiento de animales.
	if actionName == "KEYANIM" and MultiCheat.iKeyAnim ~= nil  then
		local obj = MultiCheat.obj[MultiCheat.iKeyAnim].obj;
		if obj.modulesByName.animals.owner.ownerFarmId == g_currentMission.player.farmId then
			for _, objH in pairs(obj.modulesById) do
				for index,_ in pairs(objH.fillLevels) do
					objH.fillLevels[index] = objH:getCapacity();
				end
				if objH.foodToDrop ~= nil then objH.foodToDrop = 0 end
				if objH.cleanlinessFactor ~= nil then objH.cleanlinessFactor = 1 end
				if objH.animalType ~= nil and objH.animalType == "HORSE" then
					for _, caballo in pairs(objH.animals) do
						caballo.ridingTimer = (caballo.ridingTimer + caballo.DAILY_TARGET_RIDING_TIME)
						caballo.ridingTimerSent = (caballo.ridingTimer + caballo.DAILY_TARGET_RIDING_TIME)
					end
				end
			end
		end
	end
	-- Agregar dinero
	if actionName == "KEYMONEY" and MultiCheat.iKeyMoney ~= nil then
		g_currentMission.landscapingController.playerFarm.money = g_currentMission.landscapingController.playerFarm.money + 1000000.0;
	end
end

--- Agrega una especializacion.
function MultiCheat:AddSpec(mySpecName, sfile, speclist, forceall)
	if g_specializationManager:getSpecializationByName(mySpecName) == nil then
		g_specializationManager:addSpecialization(mySpecName, mySpecName, Utils.getFilename(sfile, g_currentModDirectory), true, nil);
		for vhtype, vh in pairs(g_vehicleTypeManager.vehicleTypes) do
			local encontrado = false
			for _,specname in pairs(speclist) do
				if forceall and vh.specializationsByName[specname] == nil then vhtype = nil; end
				if not forceall and vh.specializationsByName[specname] ~= nil then encontrado = true end
			end
			if vhtype ~= nil and ((forceall) or (not forceall and encontrado)) then g_vehicleTypeManager:addSpecialization(vhtype, mySpecName) end
		end
	end
end

-- Agregar especialización
MultiCheat:AddSpec("MC_Carga","scripts/MC_Carga.lua",{"fillUnit"}, true)
--MultiCheat:AddSpec("MC_Motor","scripts/MC_Motor.lua", {"fillUnit", "motorized", "drivable", "enterable"}, true)
